Index: ddb/db_ps.c
===================================================================
RCS file: /cvs/src/sys/ddb/db_ps.c,v
retrieving revision 1.8
diff -u -r1.8 db_ps.c
--- ddb/db_ps.c	12 Jul 2003 17:54:30 -0000	1.8
+++ ddb/db_ps.c	23 Feb 2004 06:27:28 -0000
@@ -40,7 +40,7 @@
 
 #include <ddb/ddb.h>
 
-static void
+static int
 db_more(int *nl)
 {
 	++*nl;
@@ -62,11 +62,14 @@
 			break;
 		default:		/* exit */
 			db_printf("\n");
-			return;
+			return(-1);
 		}
 	}
+	return(0);
 }
 
+static void db_dump_td_tokens(thread_t td);
+
 void
 db_ps(dummy1, dummy2, dummy3, dummy4)
 	db_expr_t	dummy1;
@@ -86,12 +89,15 @@
 	else
 		p = &proc0;
 
+	if (db_more(&nl) < 0)
+	    return;
 	db_printf("  pid   proc     addr    uid  ppid  pgrp  flag stat wmesg   wchan   cmd\n");
 	while (--np >= 0) {
 		/*
 		 * XXX just take 20 for now...
 		 */
-		db_more(&nl);
+		if (db_more(&nl) < 0)
+			return;
 		if (p == NULL) {
 			printf("oops, ran out of processes early!\n");
 			break;
@@ -110,6 +116,7 @@
 			db_printf("                 ");
 		}
 		db_printf(" %s\n", p->p_comm ? p->p_comm : "");
+		db_dump_td_tokens(p->p_thread);
 
 		p = p->p_list.le_next;
 		if (p == NULL && np > 0)
@@ -120,16 +127,46 @@
 	 * Dump running threads
 	 */
 	for (cpuidx = 0; cpuidx < ncpus; ++cpuidx) {
-	    thread_t td;
 	    struct globaldata *gd = &CPU_prvspace[cpuidx].mdglobaldata.mi;
+	    thread_t td;
+	    int j;
 
+	    if (db_more(&nl) < 0)
+		return;
 	    db_printf("cpu %d tdrunqmask %08x curthread %p reqflags %04x\n",
 		    gd->gd_cpuid, gd->gd_runqmask,
 		    gd->gd_curthread, gd->gd_reqflags);
+	    if (gd->gd_tokreqbase) {
+		lwkt_tokref_t ref;
+
+		if (db_more(&nl) < 0)
+		    return;
+		db_printf("      tokenrequests:");
+		for (ref = gd->gd_tokreqbase; ref; ref = ref->tr_next) {
+		    db_printf(" [r=%p,t=%p]", ref, ref->tr_tok);
+		}
+		db_printf("\n");
+	    }
+	    if (db_more(&nl) < 0)
+		return;
+	    db_printf("      INCOMMING IPIQS:");
+	    for (j = 0; j < ncpus; ++j) {
+		lwkt_ipiq_t ip = globaldata_find(j)->gd_ipiq;
+		if (ip != NULL) {
+		    ip = &ip[cpuidx];
+		    if (ip->ip_windex != ip->ip_rindex)
+			db_printf(" cpu%d:%d", j, ip->ip_windex - ip->ip_rindex);
+		}
+	    }
+	    db_printf("\n");
+
+	    if (db_more(&nl) < 0)
+		return;
 	    db_printf("  tdq     thread    pid flags  pri(act)        sp    wmesg comm\n");
 	    for (np = 0; np < 32; ++np) {
 		TAILQ_FOREACH(td, &gd->gd_tdrunq[np], td_threadq) {
-		    db_more(&nl);
+		    if (db_more(&nl) < 0)
+			return;
 		    db_printf("  %3d %p %3d %08x %3d(%3d) %p %8.8s %s\n",
 			np, td, 
 			(td->td_proc ? td->td_proc->p_pid : -1),
@@ -138,12 +175,18 @@
 			td->td_sp,
 			td->td_wmesg ? td->td_wmesg : "-",
 			td->td_proc ? td->td_proc->p_comm : td->td_comm);
+		    db_dump_td_tokens(td);
 		}
 	    }
+	    if (db_more(&nl) < 0)
+		return;
 	    db_printf("\n");
+	    if (db_more(&nl) < 0)
+		return;
 	    db_printf("  tdq     thread    pid flags  pri(act)        sp    wmesg comm\n");
 	    TAILQ_FOREACH(td, &gd->gd_tdallq, td_allq) {
-		db_more(&nl);
+		if (db_more(&nl) < 0)
+		    return;
 		db_printf("  %3d %p %3d %08x %3d(%3d) %p %8.8s %s\n",
 		    np, td, 
 		    (td->td_proc ? td->td_proc->p_pid : -1),
@@ -152,11 +195,42 @@
 		    td->td_sp,
 		    td->td_wmesg ? td->td_wmesg : "-",
 		    td->td_proc ? td->td_proc->p_comm : td->td_comm);
+		db_dump_td_tokens(td);
 	    }
 	}
-	printf("CURCPU %d CURTHREAD %p (%d)\n",
+	if (db_more(&nl) < 0)
+	    return;
+	db_printf("CURCPU %d CURTHREAD %p (%d)\n",
 	    mycpu->gd_cpuid,
 	    curthread,
 	    (curthread->td_proc ? curthread->td_proc->p_pid : -1)
 	);
+	db_dump_td_tokens(curthread);
+}
+
+static void
+db_dump_td_tokens(thread_t td)
+{
+	lwkt_tokref_t ref;
+	lwkt_token_t tok;
+
+	if (td->td_toks == NULL)
+		return;
+	db_printf("    TOKENS:");
+	for (ref = td->td_toks; ref; ref = ref->tr_next) {
+		tok = ref->tr_tok;
+
+		db_printf(" %p[tok=%p", ref, ref->tr_tok);
+		if (td->td_gd == tok->t_cpu)
+		    db_printf(",held");
+		if (ref->tr_magic == LWKT_TOKREF_MAGIC1)
+		    ;
+		else if (ref->tr_magic == LWKT_TOKREF_MAGIC2)
+		    db_printf(",wait");
+		else
+		    db_printf(",badmagic");
+		db_printf("]");
+	}
+	db_printf("\n");
 }
+
Index: dev/acpica5/acpi_ec.c
===================================================================
RCS file: /cvs/src/sys/dev/acpica5/acpi_ec.c,v
retrieving revision 1.1
diff -u -r1.1 acpi_ec.c
--- dev/acpica5/acpi_ec.c	21 Feb 2004 06:48:08 -0000	1.1
+++ dev/acpica5/acpi_ec.c	22 Feb 2004 07:24:40 -0000
@@ -269,7 +269,7 @@
 
     int			ec_glk;
     int			ec_glkhandle;
-    struct lwkt_token	ec_token;
+    struct lwkt_rwlock	ec_rwlock;
     int			ec_polldelay;
 };
 
@@ -304,13 +304,13 @@
     ACPI_STATUS	status = AE_OK;
 
     /* Always acquire this EC's mutex. */
-    lwkt_gettoken(&sc->ec_token);
+    lwkt_exlock(&sc->ec_rwlock, "acpi2");
 
     /* If _GLK is non-zero, also acquire the global lock. */
     if (sc->ec_glk) {
 	status = AcpiAcquireGlobalLock(EC_LOCK_TIMEOUT, &sc->ec_glkhandle);
 	if (ACPI_FAILURE(status))
-	    lwkt_reltoken(&sc->ec_token);
+	    lwkt_exunlock(&sc->ec_rwlock);
     }
 
     return (status);
@@ -321,7 +321,7 @@
 {
     if (sc->ec_glk)
 	AcpiReleaseGlobalLock(sc->ec_glkhandle);
-    lwkt_reltoken(&sc->ec_token);
+    lwkt_exunlock(&sc->ec_rwlock);
 }
 
 static void		EcGpeHandler(void *Context);
@@ -501,9 +501,9 @@
 	    if (sc->ec_glk != glk) {
 		ACPI_VPRINT(peer, acpi_device_get_parent_softc(peer),
 		    "Changing GLK from %d to %d\n", sc->ec_glk, glk);
-		lwkt_gettoken(&sc->ec_token);
+		lwkt_exlock(&sc->ec_rwlock, "acpi2");
 		sc->ec_glk = glk != 0 ? 1 : 0;
-		lwkt_reltoken(&sc->ec_token);
+		lwkt_exunlock(&sc->ec_rwlock);
 	    }
 	}
     }
@@ -525,7 +525,7 @@
     sc->ec_dev = dev;
     sc->ec_handle = acpi_get_handle(dev);
     sc->ec_polldelay = EC_POLL_DELAY;
-    lwkt_inittoken(&sc->ec_token);
+    lwkt_rwlock_init(&sc->ec_rwlock);
 
     /* Retrieve previously probed values via device ivars. */
     magic = acpi_get_magic(dev);
Index: dev/acpica5/Osd/OsdSynch.c
===================================================================
RCS file: /cvs/src/sys/dev/acpica5/Osd/OsdSynch.c,v
retrieving revision 1.1
diff -u -r1.1 OsdSynch.c
--- dev/acpica5/Osd/OsdSynch.c	21 Feb 2004 06:48:09 -0000	1.1
+++ dev/acpica5/Osd/OsdSynch.c	22 Feb 2004 00:34:02 -0000
@@ -349,29 +349,27 @@
 ACPI_STATUS
 AcpiOsCreateLock (ACPI_HANDLE *OutHandle)
 {
-    lwkt_token_t tok;
+    lwkt_rwlock_t lock;
 
     if (OutHandle == NULL)
 	return (AE_BAD_PARAMETER);
-    MALLOC(tok, lwkt_token_t, sizeof(*tok), M_ACPISEM, M_WAITOK | M_ZERO);
-    if (tok == NULL)
+    MALLOC(lock, lwkt_rwlock_t, sizeof(*lock), M_ACPISEM, M_WAITOK | M_ZERO);
+    if (lock == NULL)
 	return (AE_NO_MEMORY);
 
-    lwkt_inittoken(tok);
-    *OutHandle = (ACPI_HANDLE)tok;
+    lwkt_rwlock_init(lock);
+    *OutHandle = (ACPI_HANDLE)lock;
     return (AE_OK);
 }
 
 void
 AcpiOsDeleteLock (ACPI_HANDLE Handle)
 {
-#if 0
-    lwkt_token_t tok = (lwkt_token_t)Handle;
+    lwkt_rwlock_t lock = (lwkt_rwlock_t)Handle;
 
     if (Handle == NULL)
         return;
-    /*mtx_destroy(m);*/
-#endif
+    lwkt_rwlock_uninit(lock);
 }
 
 /*
@@ -382,19 +380,19 @@
 void
 AcpiOsAcquireLock (ACPI_HANDLE Handle, UINT32 Flags)
 {
-    lwkt_token_t tok = (lwkt_token_t)Handle;
+    lwkt_rwlock_t lock = (lwkt_rwlock_t)Handle;
 
     if (Handle == NULL)
         return;
-    lwkt_gettoken(tok);
+    lwkt_exlock(lock, "acpi1");
 }
 
 void
 AcpiOsReleaseLock (ACPI_HANDLE Handle, UINT32 Flags)
 {
-    lwkt_token_t tok = (lwkt_token_t)Handle;
+    lwkt_rwlock_t lock = (lwkt_rwlock_t)Handle;
 
     if (Handle == NULL)
         return;
-    lwkt_reltoken(tok);
+    lwkt_exunlock(lock);
 }
Index: dev/agp/agp.c
===================================================================
RCS file: /cvs/src/sys/dev/agp/agp.c,v
retrieving revision 1.9
diff -u -r1.9 agp.c
--- dev/agp/agp.c	20 Jan 2004 05:04:03 -0000	1.9
+++ dev/agp/agp.c	22 Feb 2004 04:50:46 -0000
@@ -278,7 +278,7 @@
 {
 	struct agp_softc *sc = device_get_softc(dev);
 	bus_release_resource(dev, SYS_RES_MEMORY, AGP_APBASE, sc->as_aperture);
-	lockmgr(&sc->as_lock, LK_DRAIN, 0, curthread); /* XXX */
+	lockmgr(&sc->as_lock, LK_DRAIN, NULL, curthread); /* XXX */
 	destroy_dev(sc->as_devnode);
 	agp_flush_cache();
 	return 0;
@@ -491,7 +491,7 @@
 	vm_page_t m;
 	int error;
 
-	lockmgr(&sc->as_lock, LK_EXCLUSIVE, 0, curthread); /* XXX */
+	lockmgr(&sc->as_lock, LK_EXCLUSIVE, NULL, curthread); /* XXX */
 
 	if (mem->am_is_bound) {
 		device_printf(dev, "memory already bound\n");
@@ -554,7 +554,7 @@
 							   OFF_TO_IDX(k));
 					vm_page_unwire(m, 0);
 				}
-				lockmgr(&sc->as_lock, LK_RELEASE, 0, curthread); /* XXX */
+				lockmgr(&sc->as_lock, LK_RELEASE, NULL, curthread); /* XXX */
 				return error;
 			}
 		}
@@ -575,7 +575,7 @@
 	mem->am_offset = offset;
 	mem->am_is_bound = 1;
 
-	lockmgr(&sc->as_lock, LK_RELEASE, 0, curthread); /* XXX */
+	lockmgr(&sc->as_lock, LK_RELEASE, NULL, curthread); /* XXX */
 
 	return 0;
 }
@@ -587,7 +587,7 @@
 	vm_page_t m;
 	int i;
 
-	lockmgr(&sc->as_lock, LK_EXCLUSIVE, 0, curthread); /* XXX */
+	lockmgr(&sc->as_lock, LK_EXCLUSIVE, NULL, curthread); /* XXX */
 
 	if (!mem->am_is_bound) {
 		device_printf(dev, "memory is not bound\n");
@@ -612,7 +612,7 @@
 	mem->am_offset = 0;
 	mem->am_is_bound = 0;
 
-	lockmgr(&sc->as_lock, LK_RELEASE, 0, curthread); /* XXX */
+	lockmgr(&sc->as_lock, LK_RELEASE, NULL, curthread); /* XXX */
 
 	return 0;
 }
Index: dev/disk/ccd/ccd.c
===================================================================
RCS file: /cvs/src/sys/dev/disk/ccd/ccd.c,v
retrieving revision 1.12
diff -u -r1.12 ccd.c
--- dev/disk/ccd/ccd.c	23 Sep 2003 05:03:40 -0000	1.12
+++ dev/disk/ccd/ccd.c	22 Feb 2004 05:33:17 -0000
@@ -1578,12 +1578,12 @@
 		vprint("ccdlookup: vnode info", vp);
 #endif
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	*vpp = vp;
 	return (0);
 bad:
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	/* vn_close does vrele() for vp */
 	(void)vn_close(vp, FREAD|FWRITE, td);
Index: dev/disk/vn/vn.c
===================================================================
RCS file: /cvs/src/sys/dev/disk/vn/vn.c,v
retrieving revision 1.7
diff -u -r1.7 vn.c
--- dev/disk/vn/vn.c	23 Sep 2003 05:03:46 -0000	1.7
+++ dev/disk/vn/vn.c	22 Feb 2004 05:50:14 -0000
@@ -387,12 +387,12 @@
 			auio.uio_rw = UIO_WRITE;
 		auio.uio_resid = bp->b_bcount;
 		auio.uio_td = curthread;
-		vn_lock(vn->sc_vp, LK_EXCLUSIVE | LK_RETRY, curthread);
+		vn_lock(vn->sc_vp, NULL, LK_EXCLUSIVE | LK_RETRY, curthread);
 		if (bp->b_flags & B_READ)
 			error = VOP_READ(vn->sc_vp, &auio, IO_DIRECT, vn->sc_cred);
 		else
 			error = VOP_WRITE(vn->sc_vp, &auio, IO_NOWDRAIN, vn->sc_cred);
-		VOP_UNLOCK(vn->sc_vp, 0, curthread);
+		VOP_UNLOCK(vn->sc_vp, NULL, 0, curthread);
 		bp->b_resid = auio.uio_resid;
 
 		if (error) {
@@ -560,11 +560,11 @@
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	if (nd.ni_vp->v_type != VREG ||
 	    (error = VOP_GETATTR(nd.ni_vp, &vattr, td))) {
-		VOP_UNLOCK(nd.ni_vp, 0, td);
+		VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
 		(void) vn_close(nd.ni_vp, flags, td);
 		return (error ? error : EINVAL);
 	}
-	VOP_UNLOCK(nd.ni_vp, 0, td);
+	VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
 	vn->sc_secsize = DEV_BSIZE;
 	vn->sc_vp = nd.ni_vp;
 
@@ -715,9 +715,9 @@
 		auio.uio_rw = UIO_READ;
 		auio.uio_segflg = UIO_SYSSPACE;
 		auio.uio_resid = aiov.iov_len;
-		vn_lock(vn->sc_vp, LK_EXCLUSIVE | LK_RETRY, curthread);
+		vn_lock(vn->sc_vp, NULL, LK_EXCLUSIVE | LK_RETRY, curthread);
 		error = VOP_READ(vn->sc_vp, &auio, 0, vn->sc_cred);
-		VOP_UNLOCK(vn->sc_vp, 0, curthread);
+		VOP_UNLOCK(vn->sc_vp, NULL, 0, curthread);
 		free(tmpbuf, M_TEMP);
 	}
 	return (error);
Index: dev/drm/drm_os_freebsd.h
===================================================================
RCS file: /cvs/src/sys/dev/drm/drm_os_freebsd.h,v
retrieving revision 1.8
diff -u -r1.8 drm_os_freebsd.h
--- dev/drm/drm_os_freebsd.h	13 Feb 2004 01:23:57 -0000	1.8
+++ dev/drm/drm_os_freebsd.h	22 Feb 2004 04:50:55 -0000
@@ -94,11 +94,11 @@
 #else
 #define DRM_CURPROC		curthread
 #define DRM_STRUCTPROC		struct thread
-#define DRM_SPINTYPE		struct lwkt_token
-#define DRM_SPININIT(l,name)	lwkt_inittoken(&l)
+#define DRM_SPINTYPE		struct lwkt_rwlock
+#define DRM_SPININIT(l,name)	lwkt_rwlock_init(&l)
 #define DRM_SPINUNINIT(l)
-#define DRM_SPINLOCK(l)		lwkt_gettoken(l)
-#define DRM_SPINUNLOCK(u)	lwkt_reltoken(u);
+#define DRM_SPINLOCK(l)		lwkt_exlock(l, "drm")
+#define DRM_SPINUNLOCK(u)	lwkt_exunlock(u);
 #define DRM_CURRENTPID		curthread->td_proc->p_pid
 #endif
 
@@ -107,8 +107,8 @@
  * code for that is not yet written */
 #define DRMFILE			void *
 #define DRM_IOCTL_ARGS		dev_t kdev, u_long cmd, caddr_t data, int flags, DRM_STRUCTPROC *p, DRMFILE filp
-#define DRM_LOCK		lockmgr(&dev->dev_lock, LK_EXCLUSIVE, 0, DRM_CURPROC)
-#define DRM_UNLOCK 		lockmgr(&dev->dev_lock, LK_RELEASE, 0, DRM_CURPROC)
+#define DRM_LOCK		lockmgr(&dev->dev_lock, LK_EXCLUSIVE, NULL, DRM_CURPROC)
+#define DRM_UNLOCK 		lockmgr(&dev->dev_lock, LK_RELEASE, NULL, DRM_CURPROC)
 #define DRM_SUSER(td)		suser(td)
 #define DRM_TASKQUEUE_ARGS	void *arg, int pending
 #define DRM_IRQ_ARGS		void *arg
Index: dev/pccard/pccbb/pccbb.c
===================================================================
RCS file: /cvs/src/sys/dev/pccard/pccbb/pccbb.c,v
retrieving revision 1.1
diff -u -r1.1 pccbb.c
--- dev/pccard/pccbb/pccbb.c	10 Feb 2004 07:55:47 -0000	1.1
+++ dev/pccard/pccbb/pccbb.c	22 Feb 2004 04:51:14 -0000
@@ -719,14 +719,14 @@
 	if (error > 0)
 		return (ENXIO);
 
-	lockmgr(&sc->lock, LK_EXCLUSIVE, 0, curthread);
+	lockmgr(&sc->lock, LK_EXCLUSIVE, NULL, curthread);
 	bus_teardown_intr(brdev, sc->irq_res, sc->intrhand);
 	sc->flags |= CBB_KTHREAD_DONE;
 	if (sc->flags & CBB_KTHREAD_RUNNING) {
 		wakeup(sc);
 		tsleep(sc, 0, "pccbb", 0);
 	}
-	lockmgr(&sc->lock, LK_RELEASE, 0, curthread);
+	lockmgr(&sc->lock, LK_RELEASE, NULL, curthread);
 
 	bus_release_resource(brdev, SYS_RES_IRQ, 0, sc->irq_res);
 	if (sc->flags & CBB_KLUDGE_ALLOC)
@@ -894,7 +894,7 @@
 		 * if there's a card already inserted, we do the
 		 * right thing.
 		 */
-		lockmgr(&sc->lock, LK_EXCLUSIVE, 0, curthread);
+		lockmgr(&sc->lock, LK_EXCLUSIVE, NULL, curthread);
 		if (sc->flags & CBB_KTHREAD_DONE)
 			break;
 
@@ -904,7 +904,7 @@
 			cbb_insert(sc);
 		else
 			cbb_removal(sc);
-		lockmgr(&sc->lock, LK_RELEASE, 0, curthread);
+		lockmgr(&sc->lock, LK_RELEASE, NULL, curthread);
 		/* mtx_unlock(&Giant); */
 
 		/*
@@ -917,7 +917,7 @@
 		    (sc->flags & CBB_KTHREAD_DONE) == 0)
 			err = tsleep(sc, 0, "pccbb", 1 * hz);
 	}
-	lockmgr(&sc->lock, LK_RELEASE, 0, curthread);
+	lockmgr(&sc->lock, LK_RELEASE, NULL, curthread);
 	sc->flags &= ~CBB_KTHREAD_RUNNING;
 	/* mtx_lock(&Giant); */
 	kthread_exit();
@@ -1019,9 +1019,9 @@
 		 * excellent results.
 		 */
 		if (sockevent & CBB_SOCKET_EVENT_CD) {
-			lockmgr(&sc->lock, LK_EXCLUSIVE, 0, curthread);
+			lockmgr(&sc->lock, LK_EXCLUSIVE, NULL, curthread);
 			sc->flags &= ~CBB_CARD_OK;
-			lockmgr(&sc->lock, LK_RELEASE, 0, curthread);
+			lockmgr(&sc->lock, LK_RELEASE, NULL, curthread);
 			wakeup(sc);
 		}
 		if (sockevent & CBB_SOCKET_EVENT_CSTS) {
Index: dev/raid/aac/aacvar.h
===================================================================
RCS file: /cvs/src/sys/dev/raid/aac/aacvar.h,v
retrieving revision 1.5
diff -u -r1.5 aacvar.h
--- dev/raid/aac/aacvar.h	13 Feb 2004 01:33:19 -0000	1.5
+++ dev/raid/aac/aacvar.h	22 Feb 2004 00:35:21 -0000
@@ -259,10 +259,10 @@
 #define AAC_LOCK_ACQUIRE(l)	mtx_lock(l)
 #define AAC_LOCK_RELEASE(l)	mtx_unlock(l)
 #else
-typedef struct lwkt_token aac_lock_t;
-#define AAC_LOCK_INIT(l, s)	lwkt_inittoken(l)
-#define AAC_LOCK_ACQUIRE(l)	lwkt_gettoken(l)
-#define AAC_LOCK_RELEASE(l)	lwkt_reltoken(l)
+typedef struct lwkt_rwlock aac_lock_t;
+#define AAC_LOCK_INIT(l, s)	lwkt_rwlock_init(l)
+#define AAC_LOCK_ACQUIRE(l)	lwkt_exlock(l, "aac")
+#define AAC_LOCK_RELEASE(l)	lwkt_exunlock(l)
 #endif
 
 #if defined(__FreeBSD__) && __FreeBSD_version >= 500005
Index: emulation/43bsd/43bsd_file.c
===================================================================
RCS file: /cvs/src/sys/emulation/43bsd/43bsd_file.c,v
retrieving revision 1.3
diff -u -r1.3 43bsd_file.c
--- emulation/43bsd/43bsd_file.c	11 Nov 2003 09:28:15 -0000	1.3
+++ emulation/43bsd/43bsd_file.c	22 Feb 2004 05:50:20 -0000
@@ -147,7 +147,7 @@
 	auio.uio_segflg = UIO_USERSPACE;
 	auio.uio_td = td;
 	auio.uio_resid = uap->count;
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	loff = auio.uio_offset = fp->f_offset;
 #	if (BYTE_ORDER != LITTLE_ENDIAN)
 		if (vp->v_mount->mnt_maxsymlinklen <= 0) {
@@ -200,7 +200,7 @@
 		}
 		FREE(dirbuf, M_TEMP);
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (error)
 		return (error);
 	if (uap->count == auio.uio_resid) {
Index: emulation/ibcs2/coff/imgact_coff.c
===================================================================
RCS file: /cvs/src/sys/emulation/ibcs2/coff/imgact_coff.c,v
retrieving revision 1.9
diff -u -r1.9 imgact_coff.c
--- emulation/ibcs2/coff/imgact_coff.c	20 Jan 2004 18:41:49 -0000	1.9
+++ emulation/ibcs2/coff/imgact_coff.c	22 Feb 2004 05:33:51 -0000
@@ -211,7 +211,7 @@
 	 * Lose the lock on the vnode. It's no longer needed, and must not
 	 * exist for the pagefault paging to work below.
 	 */
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 
   	if ((error = vm_mmap(kernel_map,
 			    (vm_offset_t *) &ptr,
@@ -284,7 +284,7 @@
     		panic(__FUNCTION__ " vm_map_remove failed");
 
  fail:
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
  unlocked_fail:
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vrele(nd.ni_vp);
Index: emulation/ibcs2/i386/ibcs2_misc.c
===================================================================
RCS file: /cvs/src/sys/emulation/ibcs2/i386/ibcs2_misc.c,v
retrieving revision 1.8
diff -u -r1.8 ibcs2_misc.c
--- emulation/ibcs2/i386/ibcs2_misc.c	20 Aug 2003 07:13:25 -0000	1.8
+++ emulation/ibcs2/i386/ibcs2_misc.c	22 Feb 2004 05:50:30 -0000
@@ -330,7 +330,7 @@
 	buflen = max(DIRBLKSIZ, SCARG(uap, nbytes));
 	buflen = min(buflen, MAXBSIZE);
 	buf = malloc(buflen, M_TEMP, M_WAITOK);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 again:
 	aiov.iov_base = buf;
 	aiov.iov_len = buflen;
@@ -432,7 +432,7 @@
 out:
 	if (cookies)
 		free(cookies, M_TEMP);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	free(buf, M_TEMP);
 	return (error);
 }
@@ -479,7 +479,7 @@
 	buflen = max(DIRBLKSIZ, SCARG(uap, nbytes));
 	buflen = min(buflen, MAXBSIZE);
 	buf = malloc(buflen, M_TEMP, M_WAITOK);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 again:
 	aiov.iov_base = buf;
 	aiov.iov_len = buflen;
@@ -585,7 +585,7 @@
 out:
 	if (cookies)
 		free(cookies, M_TEMP);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	free(buf, M_TEMP);
 	return (error);
 }
Index: emulation/linux/linux_file.c
===================================================================
RCS file: /cvs/src/sys/emulation/linux/linux_file.c,v
retrieving revision 1.15
diff -u -r1.15 linux_file.c
--- emulation/linux/linux_file.c	15 Nov 2003 00:40:06 -0000	1.15
+++ emulation/linux/linux_file.c	22 Feb 2004 05:50:41 -0000
@@ -290,7 +290,7 @@
 	buflen = max(LINUX_DIRBLKSIZ, nbytes);
 	buflen = min(buflen, MAXBSIZE);
 	buf = malloc(buflen, M_TEMP, M_WAITOK);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 again:
 	aiov.iov_base = buf;
@@ -429,7 +429,7 @@
 	if (cookies)
 		free(cookies, M_TEMP);
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	free(buf, M_TEMP);
 	return (error);
 }
Index: emulation/linux/linux_getcwd.c
===================================================================
RCS file: /cvs/src/sys/emulation/linux/linux_getcwd.c,v
retrieving revision 1.13
diff -u -r1.13 linux_getcwd.c
--- emulation/linux/linux_getcwd.c	9 Oct 2003 22:27:08 -0000	1.13
+++ emulation/linux/linux_getcwd.c	22 Feb 2004 05:50:48 -0000
@@ -313,7 +313,7 @@
 	 *	uvp is either NULL, or locked and held.
 	 */
 
-	error = vn_lock(lvp, LK_EXCLUSIVE | LK_RETRY, td);
+	error = vn_lock(lvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (error) {
 		vrele(lvp);
 		lvp = NULL;
@@ -369,7 +369,7 @@
 				goto out;
 			}
 			VREF(lvp);
-			error = vn_lock(lvp, LK_EXCLUSIVE | LK_RETRY, td);
+			error = vn_lock(lvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			if (error != 0) {
 				vrele(lvp);
 				lvp = NULL;
Index: emulation/linux/linux_misc.c
===================================================================
RCS file: /cvs/src/sys/emulation/linux/linux_misc.c,v
retrieving revision 1.18
diff -u -r1.18 linux_misc.c
--- emulation/linux/linux_misc.c	7 Jan 2004 10:54:57 -0000	1.18
+++ emulation/linux/linux_misc.c	22 Feb 2004 05:34:08 -0000
@@ -326,7 +326,7 @@
 	/*
 	 * Lock no longer needed
 	 */
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	locked = 0;
 
 	/* Pull in executable header into kernel_map */
@@ -464,7 +464,7 @@
 cleanup:
 	/* Unlock vnode if needed */
 	if (locked)
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 
 	/* Release the kernel mapping. */
 	if (a_out)
Index: emulation/linux/i386/linprocfs/linprocfs_subr.c
===================================================================
RCS file: /cvs/src/sys/emulation/linux/i386/linprocfs/linprocfs_subr.c,v
retrieving revision 1.6
diff -u -r1.6 linprocfs_subr.c
--- emulation/linux/i386/linprocfs/linprocfs_subr.c	27 Aug 2003 06:30:04 -0000	1.6
+++ emulation/linux/i386/linprocfs/linprocfs_subr.c	22 Feb 2004 07:22:32 -0000
@@ -99,7 +99,7 @@
 		if (pfs->pfs_pid == pid &&
 		    pfs->pfs_type == pfs_type &&
 		    vp->v_mount == mp) {
-			if (vget(vp, 0, td))
+			if (vget(vp, NULL, 0, td))
 				goto loop;
 			*vpp = vp;
 			return (0);
Index: emulation/linux/i386/linprocfs/linprocfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/emulation/linux/i386/linprocfs/linprocfs_vnops.c,v
retrieving revision 1.9
diff -u -r1.9 linprocfs_vnops.c
--- emulation/linux/i386/linprocfs/linprocfs_vnops.c	23 Sep 2003 05:03:51 -0000	1.9
+++ emulation/linux/i386/linprocfs/linprocfs_vnops.c	22 Feb 2004 05:50:36 -0000
@@ -338,7 +338,7 @@
 {
 	struct vnode *vp = ap->a_vp;
 
-	VOP_UNLOCK(vp, 0, ap->a_td);
+	VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 
 	return (0);
 }
@@ -669,7 +669,7 @@
 	if (cnp->cn_namelen == 1 && *pname == '.') {
 		*vpp = dvp;
 		VREF(dvp);
-		/* vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, curp); */
+		/* vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, curp); */
 		return (0);
 	}
 
Index: emulation/svr4/svr4_misc.c
===================================================================
RCS file: /cvs/src/sys/emulation/svr4/svr4_misc.c,v
retrieving revision 1.20
diff -u -r1.20 svr4_misc.c
--- emulation/svr4/svr4_misc.c	12 Feb 2004 23:33:26 -0000	1.20
+++ emulation/svr4/svr4_misc.c	22 Feb 2004 05:50:55 -0000
@@ -286,7 +286,7 @@
 	buflen = max(DIRBLKSIZ, nbytes);
 	buflen = min(buflen, MAXBSIZE);
 	buf = malloc(buflen, M_TEMP, M_WAITOK);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 again:
 	aiov.iov_base = buf;
 	aiov.iov_len = buflen;
@@ -400,7 +400,7 @@
 out:
 	if (cookies)
 		free(cookies, M_TEMP);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	free(buf, M_TEMP);
 	return error;
 }
@@ -440,7 +440,7 @@
 
 	buflen = min(MAXBSIZE, SCARG(uap, nbytes));
 	buf = malloc(buflen, M_TEMP, M_WAITOK);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	off = fp->f_offset;
 again:
 	aiov.iov_base = buf;
@@ -514,7 +514,7 @@
 eof:
 	*retval = SCARG(uap, nbytes) - resid;
 out:
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (cookiebuf)
 		free(cookiebuf, M_TEMP);
 	free(buf, M_TEMP);
@@ -609,12 +609,12 @@
 	if ((error = getvnode(fdp, SCARG(uap, fd), &fp)) != 0)
 		return error;
 	vp = (struct vnode *) fp->f_data;
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (vp->v_type != VDIR)
 		error = ENOTDIR;
 	else
 		error = VOP_ACCESS(vp, VEXEC, cred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (error)
 		return error;
 	VREF(vp);
Index: i386/conf/LINT
===================================================================
RCS file: /cvs/src/sys/i386/conf/LINT,v
retrieving revision 1.22
diff -u -r1.22 LINT
--- i386/conf/LINT	24 Feb 2004 18:11:16 -0000	1.22
+++ i386/conf/LINT	25 Feb 2004 18:12:23 -0000
@@ -2683,8 +2683,6 @@
 options		UBSEC_DEBUG	# enable debugging support: hw.ubsec.debug
 options		UBSEC_RNDTEST	# enable rndtest support
 
-device		acpica		# basic ACPI support
-
 # DRM options:
 # mgadrm:    AGP Matrox G200, G400, G450, G550
 # tdfxdrm:   3dfx Voodoo 3/4/5 and Banshee
Index: i386/i386/machdep.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/machdep.c,v
retrieving revision 1.54
diff -u -r1.54 machdep.c
--- i386/i386/machdep.c	17 Feb 2004 19:38:53 -0000	1.54
+++ i386/i386/machdep.c	23 Feb 2004 05:56:32 -0000
@@ -2648,6 +2648,7 @@
 #ifdef SMP
 	cpu_get_initial_mplock();
 #endif
+	/* DEPRECATED */
 	spin_lock_init(&mcount_spinlock);
 	spin_lock_init(&fast_intr_spinlock);
 	spin_lock_init(&intr_spinlock);
@@ -2657,5 +2658,8 @@
 	spin_lock_init(&com_spinlock);
 	spin_lock_init(&clock_spinlock);
 	spin_lock_init(&cons_spinlock);
+
+	/* our token pool needs to work early */
+	lwkt_token_pool_init();
 }
 
Index: i386/i386/mp_machdep.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/mp_machdep.c,v
retrieving revision 1.23
diff -u -r1.23 mp_machdep.c
--- i386/i386/mp_machdep.c	21 Feb 2004 06:37:07 -0000	1.23
+++ i386/i386/mp_machdep.c	23 Feb 2004 08:24:23 -0000
@@ -280,7 +280,7 @@
 static int	mp_capable;
 static u_int	boot_address;
 static u_int	base_memory;
-static cpumask_t smp_startup_mask = 1;	/* which cpus have been started */
+static int	mp_finish;
 
 static int	picmode;		/* 0: virtual wire mode, 1: PIC mode */
 static mpfps_t	mpfps;
@@ -298,6 +298,7 @@
 static int	start_ap(struct mdglobaldata *gd, u_int boot_addr);
 static int	apic_int_is_bus_type(int intr, int bus_type);
 
+static cpumask_t smp_startup_mask = 1;	/* which cpus have been started */
 cpumask_t smp_active_mask = 1;	/* which cpus are ready for IPIs etc? */
 SYSCTL_INT(_machdep, OID_AUTO, smp_active, CTLFLAG_RD, &smp_active_mask, 0, "");
 
@@ -2313,7 +2314,6 @@
  * loop for the idlethread.  Interrupts are disabled on entry and should
  * remain disabled at return.
  */
-
 void
 ap_init(void)
 {
@@ -2332,17 +2332,27 @@
 	cpu_mb1();
 
 	/*
-	 * Get the MP lock so we can finish initializing.  Note: we are
-	 * in a critical section.  td_mpcount must always be bumped prior
-	 * to obtaining the actual lock.
+	 * Interlock for finalization.  Wait until mp_finish is non-zero,
+	 * then get the MP lock.
+	 *
+	 * Note: We are in a critical section.
+	 *
+	 * Note: We have to synchronize td_mpcount to our desired MP state
+	 * before calling cpu_try_mplock().
+	 *
+	 * Note: we are the idle thread, we can only spin.
+	 *
+	 * Note: cpu_mb1() is memory volatile and prevents mp_finish from
+	 * 	 being cached.
 	 */
 	++curthread->td_mpcount;
+	while (mp_finish == 0)
+	    cpu_mb1();
 	while (cpu_try_mplock() == 0)
 	    ;
 
 	/* BSP may have changed PTD while we're waiting for the lock */
 	cpu_invltlb();
-	smp_active_mask |= 1 << mycpu->gd_cpuid;
 
 #if defined(I586_CPU) && !defined(NO_F00F_HACK)
 	lidt(&r_idt);
@@ -2377,27 +2387,43 @@
 	/* Set memory range attributes for this CPU to match the BSP */
 	mem_range_AP_init();
 
-	/*
-	 * AP helper function for kernel memory support.  This will create
-	 * a memory reserve for the AP that is necessary to avoid certain
-	 * memory deadlock situations, such as when the kernel_map needs
-	 * a vm_map_entry and zalloc has no free entries and tries to allocate
-	 * a new one from the ... kernel_map :-)
-	 */
-	kmem_cpu_init();
-
-	sched_thread_init();	/* startup helper thread(s) one per cpu */
 	initclocks_pcpu();	/* clock interrupts (via IPIs) */
 
 	/*
 	 * The idle loop doesn't expect the BGL to be held and while
 	 * lwkt_switch() normally cleans things up this is a special case
 	 * because we returning almost directly into the idle loop.
+	 *
+	 * The idle thread is never placed on the runq, make sure
+	 * nothing we've done put it thre.
 	 */
 	KKASSERT(curthread->td_mpcount == 1);
+	smp_active_mask |= 1 << mycpu->gd_cpuid;
 	rel_mplock();
+	KKASSERT((curthread->td_flags & TDF_RUNQ) == 0);
 }
 
+/*
+ * Get SMP fully working before we start initializing devices.
+ */
+static
+void
+ap_finish(void)
+{
+	mp_finish = 1;
+	if (bootverbose)
+		printf("Finish MP startup");
+	rel_mplock();
+	while (smp_active_mask != smp_startup_mask)
+		cpu_mb1();
+	while (cpu_try_mplock() == 0)
+		;
+	if (bootverbose)
+		printf("Active CPU Mask: %08x\n", smp_active_mask);
+}
+
+SYSINIT(finishsmp, SI_SUB_FINISH_SMP, SI_ORDER_FIRST, ap_finish, NULL)
+
 #ifdef APIC_INTR_REORDER
 /*
  *     Maintain mapping from softintr vector to isr bit in local apic.
@@ -2492,6 +2518,23 @@
 void
 cpu_send_ipiq(int dcpu)
 {
-	if ((1 << dcpu) & smp_active_mask)
-		selected_apic_ipi(1 << dcpu, XIPIQ_OFFSET, APIC_DELMODE_FIXED);
+        if ((1 << dcpu) & smp_active_mask)
+                single_apic_ipi(dcpu, XIPIQ_OFFSET, APIC_DELMODE_FIXED);
 }
+
+#if 0	/* single_apic_ipi_passive() not working yet */
+/*
+ * Returns 0 on failure, 1 on success
+ */
+int
+cpu_send_ipiq_passive(int dcpu)
+{
+        int r = 0;
+        if ((1 << dcpu) & smp_active_mask) {
+                r = single_apic_ipi_passive(dcpu, XIPIQ_OFFSET,
+                                        APIC_DELMODE_FIXED);
+        }
+	return(r);
+}
+#endif
+
